Package ghidra.app.util.bin.format.elf.info

# Class GnuDebugLink

java.lang.Object
ghidra.app.util.bin.format.elf.info.GnuDebugLink

All Implemented Interfaces:
  `ElfInfoItem`

public class GnuDebugLink extends Object implements ElfInfoItem
An ELF section (almost like a `ElfNote`) that contains information about an external DWARF debug file.

External DWARF debug files can also be specified with a `NoteGnuBuildId`.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface ghidra.app.util.bin.format.elf.info.ElfInfoItem

  `ElfInfoItem.ItemWithAddress<T>, ElfInfoItem.ReaderFunc<T extends ElfInfoItem>`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `SECTION_NAME`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GnuDebugLink(int filenameLen, String filename, int crc)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static GnuDebugLink`
  `fromProgram(Program program)`
  Reads a GnuDebugLink from the standard ".gnu_debuglink" section in the specified Program.
  `int`
  `getCrc()`
  `String`
  `getFilename()`
  `int`
  `getFilenameLen()`
  `void`
  `markupProgram(Program program, Address address)`
  Markup a program's info and memory with this item.
  `static GnuDebugLink`
  `read(BinaryReader br, Program program)`
  Reads a GnuDebugLink from the specified BinaryReader.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### SECTION_NAME

    public static final String SECTION_NAME
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### GnuDebugLink

    public GnuDebugLink(int filenameLen, String filename, int crc)

- ## Method Details

  - ### fromProgram

    public static GnuDebugLink fromProgram(Program program)
    Reads a GnuDebugLink from the standard ".gnu_debuglink" section in the specified Program.
    Parameters:
      `program` - Program to read from
    Returns:
      new instance, or null if not found or data error

  - ### read

    public static GnuDebugLink read(BinaryReader br, Program program)
    Reads a GnuDebugLink from the specified BinaryReader.
    Parameters:
      `br` - BinaryReader to read from
      `program` - unused, present to match the signature of `ElfInfoItem.ReaderFunc`
    Returns:
      new instance, or null if data error

  - ### getFilename

    public String getFilename()

  - ### getFilenameLen

    public int getFilenameLen()

  - ### getCrc

    public int getCrc()

  - ### markupProgram

    public void markupProgram(Program program, Address address)
    Description copied from interface: `ElfInfoItem`
    Markup a program's info and memory with this item.
    Specified by:
      `markupProgram` in interface `ElfInfoItem`
    Parameters:
      `program` - `Program` to markup
      `address` - `Address` of the item in the program

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`